/* calls-phone-number-query.c generated by valac 0.56.9, the Vala compiler
 * generated from calls-phone-number-query.vala, do not modify */

/*
 * Copyright (C) 2019 Purism SPC
 *
 * This file is part of Calls.
 *
 * Calls is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Calls is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Calls.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Bob Ham <bob.ham@puri.sm>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */

#include "calls-vala.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <libebook-contacts/libebook-contacts.h>
#include <folks/folks.h>
#include <glib-object.h>
#include <gee.h>

enum  {
	CALLS_PHONE_NUMBER_QUERY_0_PROPERTY,
	CALLS_PHONE_NUMBER_QUERY_NUM_PROPERTIES
};
static GParamSpec* calls_phone_number_query_properties[CALLS_PHONE_NUMBER_QUERY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_EPhoneNumber_free0(var) ((var == NULL) ? NULL : (var = (_vala_EPhoneNumber_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CallsPhoneNumberQueryPrivate {
	gchar* _number;
	EPhoneNumber* _ephonenumber;
	gchar* _country_code;
};

static gint CallsPhoneNumberQuery_private_offset;
static gpointer calls_phone_number_query_parent_class = NULL;

static void _vala_EPhoneNumber_free (EPhoneNumber* self);
static guint calls_phone_number_query_real_is_match (FolksQuery* base,
                                              FolksIndividual* individual);
static void calls_phone_number_query_finalize (GObject * obj);
static GType calls_phone_number_query_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
calls_phone_number_query_get_instance_private (CallsPhoneNumberQuery* self)
{
	return G_STRUCT_MEMBER_P (self, CallsPhoneNumberQuery_private_offset);
}

static void
_vala_EPhoneNumber_free (EPhoneNumber* self)
{
#line 29 "../src/calls-phone-number-query.vala"
	g_boxed_free (e_phone_number_get_type (), self);
#line 80 "calls-phone-number-query.c"
}

CallsPhoneNumberQuery*
calls_phone_number_query_construct (GType object_type,
                                    const gchar* number,
                                    const gchar* country_code)
{
	CallsPhoneNumberQuery * self = NULL;
	gchar** match_fields = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint match_fields_length1;
	gint _match_fields_size_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 32 "../src/calls-phone-number-query.vala"
	g_return_val_if_fail (number != NULL, NULL);
#line 34 "../src/calls-phone-number-query.vala"
	_tmp0_ = folks_persona_store_detail_key (FOLKS_PERSONA_DETAIL_PHONE_NUMBERS);
#line 34 "../src/calls-phone-number-query.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 34 "../src/calls-phone-number-query.vala"
	_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 34 "../src/calls-phone-number-query.vala"
	_tmp2_[0] = _tmp1_;
#line 34 "../src/calls-phone-number-query.vala"
	match_fields = _tmp2_;
#line 34 "../src/calls-phone-number-query.vala"
	match_fields_length1 = 1;
#line 34 "../src/calls-phone-number-query.vala"
	_match_fields_size_ = match_fields_length1;
#line 37 "../src/calls-phone-number-query.vala"
	self = (CallsPhoneNumberQuery*) g_object_new (object_type, "match-fields", match_fields, NULL);
#line 39 "../src/calls-phone-number-query.vala"
	_tmp3_ = g_strdup (number);
#line 39 "../src/calls-phone-number-query.vala"
	_g_free0 (self->priv->_number);
#line 39 "../src/calls-phone-number-query.vala"
	self->priv->_number = _tmp3_;
#line 40 "../src/calls-phone-number-query.vala"
	_tmp4_ = g_strdup (country_code);
#line 40 "../src/calls-phone-number-query.vala"
	_g_free0 (self->priv->_country_code);
#line 40 "../src/calls-phone-number-query.vala"
	self->priv->_country_code = _tmp4_;
#line 128 "calls-phone-number-query.c"
	{
		EPhoneNumber* _tmp5_ = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		EPhoneNumber* _tmp8_;
		EPhoneNumber* _tmp9_;
#line 45 "../src/calls-phone-number-query.vala"
		_tmp6_ = self->priv->_number;
#line 45 "../src/calls-phone-number-query.vala"
		_tmp7_ = self->priv->_country_code;
#line 45 "../src/calls-phone-number-query.vala"
		_tmp8_ = e_phone_number_from_string (_tmp6_, _tmp7_, &_inner_error0_);
#line 45 "../src/calls-phone-number-query.vala"
		_tmp5_ = _tmp8_;
#line 45 "../src/calls-phone-number-query.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 145 "calls-phone-number-query.c"
			goto __catch0_g_error;
		}
#line 44 "../src/calls-phone-number-query.vala"
		_tmp9_ = _tmp5_;
#line 44 "../src/calls-phone-number-query.vala"
		_tmp5_ = NULL;
#line 44 "../src/calls-phone-number-query.vala"
		__vala_EPhoneNumber_free0 (self->priv->_ephonenumber);
#line 44 "../src/calls-phone-number-query.vala"
		self->priv->_ephonenumber = _tmp9_;
#line 42 "../src/calls-phone-number-query.vala"
		__vala_EPhoneNumber_free0 (_tmp5_);
#line 158 "calls-phone-number-query.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 42 "../src/calls-phone-number-query.vala"
		e = _inner_error0_;
#line 42 "../src/calls-phone-number-query.vala"
		_inner_error0_ = NULL;
#line 50 "../src/calls-phone-number-query.vala"
		_tmp10_ = self->priv->_number;
#line 50 "../src/calls-phone-number-query.vala"
		_tmp11_ = e;
#line 50 "../src/calls-phone-number-query.vala"
		_tmp12_ = _tmp11_->message;
#line 50 "../src/calls-phone-number-query.vala"
		g_debug ("calls-phone-number-query.vala:50: Failed to convert `%s' to a phone nu" \
"mber: %s", _tmp10_, _tmp12_);
#line 42 "../src/calls-phone-number-query.vala"
		_g_error_free0 (e);
#line 181 "calls-phone-number-query.c"
	}
	__finally0:
#line 42 "../src/calls-phone-number-query.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 42 "../src/calls-phone-number-query.vala"
		match_fields = (_vala_array_free (match_fields, match_fields_length1, (GDestroyNotify) g_free), NULL);
#line 42 "../src/calls-phone-number-query.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 42 "../src/calls-phone-number-query.vala"
		g_clear_error (&_inner_error0_);
#line 42 "../src/calls-phone-number-query.vala"
		return NULL;
#line 194 "calls-phone-number-query.c"
	}
#line 32 "../src/calls-phone-number-query.vala"
	match_fields = (_vala_array_free (match_fields, match_fields_length1, (GDestroyNotify) g_free), NULL);
#line 32 "../src/calls-phone-number-query.vala"
	return self;
#line 200 "calls-phone-number-query.c"
}

CallsPhoneNumberQuery*
calls_phone_number_query_new (const gchar* number,
                              const gchar* country_code)
{
#line 32 "../src/calls-phone-number-query.vala"
	return calls_phone_number_query_construct (CALLS_TYPE_PHONE_NUMBER_QUERY, number, country_code);
#line 209 "calls-phone-number-query.c"
}

static guint
calls_phone_number_query_real_is_match (FolksQuery* base,
                                        FolksIndividual* individual)
{
	CallsPhoneNumberQuery * self;
#line 58 "../src/calls-phone-number-query.vala"
	static const guint MATCH_MAX = (guint) 4;
#line 219 "calls-phone-number-query.c"
	gboolean use_ephone = FALSE;
	EPhoneNumber* _tmp0_;
	GeeIterator* iter = NULL;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeIterator* _tmp3_;
	guint match = 0U;
	GError* _inner_error0_ = NULL;
	guint result;
#line 56 "../src/calls-phone-number-query.vala"
	self = (CallsPhoneNumberQuery*) base;
#line 56 "../src/calls-phone-number-query.vala"
	g_return_val_if_fail (individual != NULL, 0U);
#line 59 "../src/calls-phone-number-query.vala"
	_tmp0_ = self->priv->_ephonenumber;
#line 59 "../src/calls-phone-number-query.vala"
	use_ephone = _tmp0_ != NULL;
#line 62 "../src/calls-phone-number-query.vala"
	_tmp1_ = folks_phone_details_get_phone_numbers ((FolksPhoneDetails*) individual);
#line 62 "../src/calls-phone-number-query.vala"
	_tmp2_ = _tmp1_;
#line 62 "../src/calls-phone-number-query.vala"
	_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 62 "../src/calls-phone-number-query.vala"
	iter = _tmp3_;
#line 64 "../src/calls-phone-number-query.vala"
	match = (guint) 0;
#line 65 "../src/calls-phone-number-query.vala"
	while (TRUE) {
#line 249 "calls-phone-number-query.c"
		gboolean _tmp4_ = FALSE;
		FolksPhoneFieldDetails* details = NULL;
		GeeIterator* _tmp6_;
		gpointer _tmp7_;
		gchar* indiv_number = NULL;
		FolksPhoneFieldDetails* _tmp8_;
		gconstpointer _tmp9_;
		gconstpointer _tmp10_;
		gchar* _tmp11_;
		guint this_match = 0U;
#line 65 "../src/calls-phone-number-query.vala"
		if (match < MATCH_MAX) {
#line 262 "calls-phone-number-query.c"
			GeeIterator* _tmp5_;
#line 65 "../src/calls-phone-number-query.vala"
			_tmp5_ = iter;
#line 65 "../src/calls-phone-number-query.vala"
			_tmp4_ = gee_iterator_next (_tmp5_);
#line 268 "calls-phone-number-query.c"
		} else {
#line 65 "../src/calls-phone-number-query.vala"
			_tmp4_ = FALSE;
#line 272 "calls-phone-number-query.c"
		}
#line 65 "../src/calls-phone-number-query.vala"
		if (!_tmp4_) {
#line 65 "../src/calls-phone-number-query.vala"
			break;
#line 278 "calls-phone-number-query.c"
		}
#line 68 "../src/calls-phone-number-query.vala"
		_tmp6_ = iter;
#line 68 "../src/calls-phone-number-query.vala"
		_tmp7_ = gee_iterator_get (_tmp6_);
#line 68 "../src/calls-phone-number-query.vala"
		details = (FolksPhoneFieldDetails*) _tmp7_;
#line 69 "../src/calls-phone-number-query.vala"
		_tmp8_ = details;
#line 69 "../src/calls-phone-number-query.vala"
		_tmp9_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp8_);
#line 69 "../src/calls-phone-number-query.vala"
		_tmp10_ = _tmp9_;
#line 69 "../src/calls-phone-number-query.vala"
		_tmp11_ = g_strdup ((const gchar*) _tmp10_);
#line 69 "../src/calls-phone-number-query.vala"
		indiv_number = _tmp11_;
#line 70 "../src/calls-phone-number-query.vala"
		this_match = (guint) 0;
#line 72 "../src/calls-phone-number-query.vala"
		if (use_ephone) {
#line 300 "calls-phone-number-query.c"
			EPhoneNumber* indiv_parsed = NULL;
			{
				EPhoneNumber* _tmp12_ = NULL;
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				EPhoneNumber* _tmp15_;
				EPhoneNumber* _tmp16_;
				EPhoneNumberMatch _result_ = 0;
				EPhoneNumber* _tmp17_;
				EPhoneNumber* _tmp18_;
#line 79 "../src/calls-phone-number-query.vala"
				_tmp13_ = indiv_number;
#line 79 "../src/calls-phone-number-query.vala"
				_tmp14_ = self->priv->_country_code;
#line 79 "../src/calls-phone-number-query.vala"
				_tmp15_ = e_phone_number_from_string (_tmp13_, _tmp14_, &_inner_error0_);
#line 79 "../src/calls-phone-number-query.vala"
				_tmp12_ = _tmp15_;
#line 79 "../src/calls-phone-number-query.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 321 "calls-phone-number-query.c"
					goto __catch0_g_error;
				}
#line 78 "../src/calls-phone-number-query.vala"
				_tmp16_ = _tmp12_;
#line 78 "../src/calls-phone-number-query.vala"
				_tmp12_ = NULL;
#line 78 "../src/calls-phone-number-query.vala"
				__vala_EPhoneNumber_free0 (indiv_parsed);
#line 78 "../src/calls-phone-number-query.vala"
				indiv_parsed = _tmp16_;
#line 81 "../src/calls-phone-number-query.vala"
				_tmp17_ = indiv_parsed;
#line 81 "../src/calls-phone-number-query.vala"
				_tmp18_ = self->priv->_ephonenumber;
#line 81 "../src/calls-phone-number-query.vala"
				_result_ = e_phone_number_compare (_tmp17_, _tmp18_);
#line 84 "../src/calls-phone-number-query.vala"
				switch (_result_) {
#line 84 "../src/calls-phone-number-query.vala"
					case E_PHONE_NUMBER_MATCH_NONE:
#line 342 "calls-phone-number-query.c"
					{
#line 86 "../src/calls-phone-number-query.vala"
						this_match = (guint) 0;
#line 86 "../src/calls-phone-number-query.vala"
						break;
#line 348 "calls-phone-number-query.c"
					}
#line 84 "../src/calls-phone-number-query.vala"
					case E_PHONE_NUMBER_MATCH_SHORT:
#line 352 "calls-phone-number-query.c"
					{
#line 87 "../src/calls-phone-number-query.vala"
						this_match = (guint) 0;
#line 87 "../src/calls-phone-number-query.vala"
						break;
#line 358 "calls-phone-number-query.c"
					}
#line 84 "../src/calls-phone-number-query.vala"
					case E_PHONE_NUMBER_MATCH_NATIONAL:
#line 362 "calls-phone-number-query.c"
					{
#line 88 "../src/calls-phone-number-query.vala"
						this_match = (guint) 1;
#line 88 "../src/calls-phone-number-query.vala"
						break;
#line 368 "calls-phone-number-query.c"
					}
#line 84 "../src/calls-phone-number-query.vala"
					case E_PHONE_NUMBER_MATCH_EXACT:
#line 372 "calls-phone-number-query.c"
					{
#line 89 "../src/calls-phone-number-query.vala"
						this_match = MATCH_MAX;
#line 89 "../src/calls-phone-number-query.vala"
						break;
#line 378 "calls-phone-number-query.c"
					}
					default:
					{
#line 90 "../src/calls-phone-number-query.vala"
						this_match = (guint) 0;
#line 90 "../src/calls-phone-number-query.vala"
						break;
#line 386 "calls-phone-number-query.c"
					}
				}
#line 76 "../src/calls-phone-number-query.vala"
				__vala_EPhoneNumber_free0 (_tmp12_);
#line 391 "calls-phone-number-query.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				const gchar* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				GError* _tmp22_;
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp25_;
#line 76 "../src/calls-phone-number-query.vala"
				e = _inner_error0_;
#line 76 "../src/calls-phone-number-query.vala"
				_inner_error0_ = NULL;
#line 96 "../src/calls-phone-number-query.vala"
				_tmp19_ = indiv_number;
#line 96 "../src/calls-phone-number-query.vala"
				_tmp20_ = folks_individual_get_display_name (individual);
#line 96 "../src/calls-phone-number-query.vala"
				_tmp21_ = _tmp20_;
#line 96 "../src/calls-phone-number-query.vala"
				_tmp22_ = e;
#line 96 "../src/calls-phone-number-query.vala"
				_tmp23_ = _tmp22_->message;
#line 96 "../src/calls-phone-number-query.vala"
				g_debug ("Error parsing Folks phone number `%s'" " for Individual `%s': %s", _tmp19_, _tmp21_, _tmp23_);
#line 102 "../src/calls-phone-number-query.vala"
				_tmp24_ = self->priv->_number;
#line 102 "../src/calls-phone-number-query.vala"
				_tmp25_ = indiv_number;
#line 102 "../src/calls-phone-number-query.vala"
				if (g_strcmp0 (_tmp24_, _tmp25_) == 0) {
#line 104 "../src/calls-phone-number-query.vala"
					this_match = MATCH_MAX;
#line 428 "calls-phone-number-query.c"
				}
#line 76 "../src/calls-phone-number-query.vala"
				_g_error_free0 (e);
#line 432 "calls-phone-number-query.c"
			}
			__finally0:
#line 76 "../src/calls-phone-number-query.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 437 "calls-phone-number-query.c"
				guint _tmp26_ = 0U;
#line 76 "../src/calls-phone-number-query.vala"
				__vala_EPhoneNumber_free0 (indiv_parsed);
#line 76 "../src/calls-phone-number-query.vala"
				_g_free0 (indiv_number);
#line 76 "../src/calls-phone-number-query.vala"
				_g_object_unref0 (details);
#line 76 "../src/calls-phone-number-query.vala"
				_g_object_unref0 (iter);
#line 76 "../src/calls-phone-number-query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 76 "../src/calls-phone-number-query.vala"
				g_clear_error (&_inner_error0_);
#line 76 "../src/calls-phone-number-query.vala"
				return _tmp26_;
#line 453 "calls-phone-number-query.c"
			}
#line 72 "../src/calls-phone-number-query.vala"
			__vala_EPhoneNumber_free0 (indiv_parsed);
#line 457 "calls-phone-number-query.c"
		} else {
			const gchar* _tmp27_;
			const gchar* _tmp28_;
#line 112 "../src/calls-phone-number-query.vala"
			_tmp27_ = self->priv->_number;
#line 112 "../src/calls-phone-number-query.vala"
			_tmp28_ = indiv_number;
#line 112 "../src/calls-phone-number-query.vala"
			if (g_strcmp0 (_tmp27_, _tmp28_) == 0) {
#line 114 "../src/calls-phone-number-query.vala"
				this_match = MATCH_MAX;
#line 469 "calls-phone-number-query.c"
			}
		}
#line 118 "../src/calls-phone-number-query.vala"
		if (this_match > match) {
#line 120 "../src/calls-phone-number-query.vala"
			match = this_match;
#line 476 "calls-phone-number-query.c"
		}
#line 65 "../src/calls-phone-number-query.vala"
		_g_free0 (indiv_number);
#line 65 "../src/calls-phone-number-query.vala"
		_g_object_unref0 (details);
#line 482 "calls-phone-number-query.c"
	}
#line 124 "../src/calls-phone-number-query.vala"
	result = match;
#line 124 "../src/calls-phone-number-query.vala"
	_g_object_unref0 (iter);
#line 124 "../src/calls-phone-number-query.vala"
	return result;
#line 490 "calls-phone-number-query.c"
}

static void
calls_phone_number_query_class_init (CallsPhoneNumberQueryClass * klass,
                                     gpointer klass_data)
{
#line 26 "../src/calls-phone-number-query.vala"
	calls_phone_number_query_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/calls-phone-number-query.vala"
	g_type_class_adjust_private_offset (klass, &CallsPhoneNumberQuery_private_offset);
#line 26 "../src/calls-phone-number-query.vala"
	((FolksQueryClass *) klass)->is_match = (guint (*) (FolksQuery*, FolksIndividual*)) calls_phone_number_query_real_is_match;
#line 26 "../src/calls-phone-number-query.vala"
	G_OBJECT_CLASS (klass)->finalize = calls_phone_number_query_finalize;
#line 505 "calls-phone-number-query.c"
}

static void
calls_phone_number_query_instance_init (CallsPhoneNumberQuery * self,
                                        gpointer klass)
{
#line 26 "../src/calls-phone-number-query.vala"
	self->priv = calls_phone_number_query_get_instance_private (self);
#line 514 "calls-phone-number-query.c"
}

static void
calls_phone_number_query_finalize (GObject * obj)
{
	CallsPhoneNumberQuery * self;
#line 26 "../src/calls-phone-number-query.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CALLS_TYPE_PHONE_NUMBER_QUERY, CallsPhoneNumberQuery);
#line 28 "../src/calls-phone-number-query.vala"
	_g_free0 (self->priv->_number);
#line 29 "../src/calls-phone-number-query.vala"
	__vala_EPhoneNumber_free0 (self->priv->_ephonenumber);
#line 30 "../src/calls-phone-number-query.vala"
	_g_free0 (self->priv->_country_code);
#line 26 "../src/calls-phone-number-query.vala"
	G_OBJECT_CLASS (calls_phone_number_query_parent_class)->finalize (obj);
#line 531 "calls-phone-number-query.c"
}

static GType
calls_phone_number_query_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CallsPhoneNumberQueryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) calls_phone_number_query_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CallsPhoneNumberQuery), 0, (GInstanceInitFunc) calls_phone_number_query_instance_init, NULL };
	GType calls_phone_number_query_type_id;
	calls_phone_number_query_type_id = g_type_register_static (FOLKS_TYPE_QUERY, "CallsPhoneNumberQuery", &g_define_type_info, 0);
	CallsPhoneNumberQuery_private_offset = g_type_add_instance_private (calls_phone_number_query_type_id, sizeof (CallsPhoneNumberQueryPrivate));
	return calls_phone_number_query_type_id;
}

GType
calls_phone_number_query_get_type (void)
{
	static volatile gsize calls_phone_number_query_type_id__once = 0;
	if (g_once_init_enter (&calls_phone_number_query_type_id__once)) {
		GType calls_phone_number_query_type_id;
		calls_phone_number_query_type_id = calls_phone_number_query_get_type_once ();
		g_once_init_leave (&calls_phone_number_query_type_id__once, calls_phone_number_query_type_id);
	}
	return calls_phone_number_query_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

